# Generated by Django 3.2.12 on 2022-04-11 12:32

from django.db import migrations
from django.db.models import F, OuterRef, Subquery
from django.contrib.postgres.functions import RandomUUID
from django.contrib.postgres.operations import CryptoExtension


def set_order_line_token_and_created_at(apps, _schema_editor):
    OrderLine = apps.get_model("order", "OrderLine")
    Order = apps.get_model("order", "Order")

    OrderLine.objects.filter(token__isnull=True).update(
        token=RandomUUID(),
        created_at=Subquery(
            Order.objects.filter(lines=OuterRef("id")).values("created_at")[:1]
        ),
    )


def set_order_line_old_id(apps, schema_editor):
    OrderLine = apps.get_model("order", "OrderLine")
    OrderLine.objects.all().update(old_id=F("id"))


class Migration(migrations.Migration):

    dependencies = [
        ("order", "0138_add_orderline_token_old_id_created_at"),
    ]

    operations = [
        CryptoExtension(),
        migrations.RunPython(
            set_order_line_token_and_created_at,
            migrations.RunPython.noop,
        ),
        migrations.RunPython(
            set_order_line_old_id, reverse_code=migrations.RunPython.noop
        ),
    ]
