# Generated by Django 3.2.13 on 2022-05-18 07:32

import django.contrib.postgres.fields
from django.db import migrations, models


def update_available_actions(apps, schema_editor):
    TransactionItem = apps.get_model("payment", "TransactionItem")
    transactions = TransactionItem.objects.filter(
        available_actions__contains=["capture"]
    )
    transaction_to_update = []
    for transaction in transactions:
        transaction.available_actions.remove("capture")
        transaction.available_actions.append("charge")
        transaction_to_update.append(transaction)
    TransactionItem.objects.bulk_update(transaction_to_update, ["available_actions"])


class Migration(migrations.Migration):

    dependencies = [
        ("payment", "0035_auto_20220421_0615"),
    ]

    operations = [
        migrations.RenameField(
            model_name="transactionitem",
            old_name="captured_value",
            new_name="charged_value",
        ),
        migrations.AlterField(
            model_name="transactionitem",
            name="available_actions",
            field=django.contrib.postgres.fields.ArrayField(
                base_field=models.CharField(
                    choices=[
                        ("charge", "Charge payment"),
                        ("refund", "Refund payment"),
                        ("void", "Void payment"),
                    ],
                    max_length=128,
                ),
                default=list,
                size=None,
            ),
        ),
        migrations.RunPython(update_available_actions, migrations.RunPython.noop),
    ]
